<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>

<head>
	<title>SQL AssignmentBot 5000</title>
	<link href="css/prettify.css" type="text/css" rel="stylesheet" />
	<script type="text/javascript" src="js/prettify.js"></script>
	<script src="js/jquery-1.8.3.js"></script>
	<script>
		$(document).ready(function(){
		prettyPrint();
		});
		
		function displayResults(result){
			$('#result').html("<h2>Your Result</h2></br>" + result.queryResult + "</br><h2>Differences:</h2>" + result.differenceResult);
		}
		
		function runQuery(){
			$.post( "testquery.php",$('#sqlform').serialize(),
			function(data){
				displayResults(data);
			},
			"json");
		}
	</script>
</head>

<body>
	<form id="sqlform">
		<fieldset>
			<legend>Question 1</legend>
			<div>Find the number of certifications held by people grouped by planet. This should have two columns the first, "name" will be the names of planets that have at least one certification. The second column should be "CertCount" and will be the number of certifications held by people from that planet for example if Lee is certified in "Viper" and "Mechanic" and Kara is certified in "Viper" and they are both from Caprica, then the "CertCount" for caprica should be 3:</div>
			<div>
				<pre class="prettyprint lang-sql">

CREATE TABLE `bsg_cert` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB

CREATE TABLE `bsg_cert_people` (
  `cid` int(11) NOT NULL DEFAULT '0',
  `pid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`,`pid`),
  KEY `pid` (`pid`),
  CONSTRAINT `bsg_cert_people_ibfk_1` FOREIGN KEY (`cid`) REFERENCES `bsg_cert` (`id`),
  CONSTRAINT `bsg_cert_people_ibfk_2` FOREIGN KEY (`pid`) REFERENCES `bsg_people` (`id`)
) ENGINE=InnoDB

CREATE TABLE `bsg_people` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fname` varchar(255) NOT NULL,
  `lname` varchar(255) DEFAULT NULL,
  `homeworld` int(11) DEFAULT NULL,
  `age` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `homeworld` (`homeworld`),
  CONSTRAINT `bsg_people_ibfk_1` FOREIGN KEY (`homeworld`) REFERENCES `bsg_planets` (`id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB

CREATE TABLE `bsg_planets` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `population` bigint(20) DEFAULT NULL,
  `language` varchar(255) DEFAULT NULL,
  `capital` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB
				</pre>
			</div>
			<div>
				<label for="studentsql">Your MySQL query:</label><br/>
				<textarea rows="5" cols="80" name="studentsql"></textarea>
			</div>
			<input type="hidden" name="assignment" value="4" />
			<button type="button" onclick="runQuery()">Test SQL</button>
		</fieldset>
	</form>
	<div id="result">
	</div>
</body>

</html>