<?php
ini_set('display_errors', 'On'); 

function tableify( $result ){
	$genTable ='<table border="1" cellpadding="10">';
	$result->data_seek(0);
	$genTable .= '<tr>';
	while( $field = $result->fetch_field() ){
		$genTable .= '<td>' . $field->name . '</td>';
	}
	$genTable .= '</tr>';
	while( $row = $result->fetch_row() ){
		$genTable .= '<tr>';
		foreach( $row as $v ){
		$genTable .= '<td>' . $v . '</td>';
		}
		$genTable .= '</tr>';
	}
	$genTable .= '</table>';
	return $genTable;
}

function compareResults( $query1, $query2, $mysqli ){
	if( !$result1 = $mysqli->query($query1) )
	{
		return "Query failed: (" . $mysqli->errno . ") " . $mysqli->error;
	}
	$result2 = $mysqli->query($query2);
	while( $f1 = $result1->fetch_field() ){
		$fields1[] = $f1->name;
	}
	while( $f2 = $result2->fetch_field() ){
		$fields2[] = $f2->name;
	}
	
	$result1->free();
	$result2->free();
	
	if( count($fields1) != count($fields2) ){
		return "Column count mismatch";
	}
	
	if( count(array_diff($fields1, $fields2)) >= 1 ){
		return "Incorrect columns selected";
	}
	
	$queryString = "SELECT MIN(TableName) as TableName, " . implode(', ', $fields1) . 
	" FROM( SELECT 'StudentExtra' as TableName, A." . implode(', A.', $fields1 ) .
	" FROM( " . $query1 . ") A UNION ALL " . 
	" SELECT 'StudentMissing' as TableName, B." . implode(', B.', $fields2 ) .
	" FROM ( " . $query2 . ") B ) C " . 
	" GROUP BY " . implode(', ', $fields1) .
	" HAVING COUNT(*) = 1 ORDER BY " . $fields1[0];
	
	$diffResult = $mysqli->query($queryString);
	if (!$diffResult){
		echo json_encode(array("differenceResult"=>("Query failed: (" . $mysqli->errno . ") " . $mysqli->error)));
		return;
	}
	
	return $diffResult;
}


if($_POST['assignment'] == 1){
$profQuery = "select population from bsg_planets where name='Gemenon'";
$answerCode = "Kerbal";
}

if($_POST['assignment'] == 2){
$profQuery = "select name, population from bsg_planets where population<2600000000";
$answerCode = "Haskell";
}

if($_POST['assignment'] == 3){
$profQuery = "select fname, lname, age from bsg_people where lname<>'Adama'";
$answerCode = "Nexus";
}

if($_POST['assignment'] == 4){
$profQuery = "SELECT pl.name, count(c.title) AS 'CertCount' FROM bsg_cert c INNER JOIN bsg_cert_people cp ON cp.cid = c.id INNER JOIN bsg_people p ON p.id = cp.pid INNER JOIN bsg_planets pl ON pl.id = p.homeworld GROUP BY pl.name";
$answerCode = "Bamboo";
}


$mysqli = new mysqli("mysql.eecs.oregonstate.edu", "CS275S", "4mmhy3K8vrSbyzbh", "CS275");
if ($mysqli->connect_errno) {
	echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
}

$_POST['studentsql'] = trim($_POST['studentsql'],';');

$result = $mysqli->query($_POST['studentsql']);
if (!$result){
	echo json_encode(array("differenceResult"=>("Query failed: (" . $mysqli->errno . ") " . $mysqli->error)));
	return;
} else if( $result->num_rows == 0) {
	echo json_encode(array("queryResult"=>"You returned an empty set", "differenceResult"=>"The correct result has > 1 row."));
	return;
} else {
	$studentTable = tableify( $result );
	$result->free();
}

$diffTable = compareResults($_POST['studentsql'],$profQuery,$mysqli);

if(!isset($diffTable->num_rows))
{
echo json_encode(array("queryResult"=>$diffTable, "differenceResult"=>$diffTable));
return;
}

if($diffTable->num_rows == 0)
{
	echo json_encode(array("queryResult"=>$studentTable, "differenceResult"=>"Correct, the code is: ".$answerCode));
	return;
}

$diffTable = tableify($diffTable);
	
echo json_encode(array("queryResult"=>$studentTable, "differenceResult"=>$diffTable));
?>